Unit qs81e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, QS80E_p, UTQS13_p;

procedure qs81e(var RINT :Extended; N :Integer; var A :Array of Extended;
                var B :Array of Extended; F :Func_F1AE; E :Extended;
                var NP :Array of Integer; var X :Array of Extended;
                var W :Array of Extended; var IERR :Integer);

implementation

procedure qs81e(var RINT :Extended; N :Integer; var A :Array of Extended;
                var B :Array of Extended; F :Func_F1AE; E :Extended;
                var NP :Array of Integer; var X :Array of Extended;
                var W :Array of Extended; var IERR :Integer);
var
IS_,I,NN,MK,KN,N2,J,IN_,L,MN,KK :Integer;
FN,RX,RW,V,R,S,R1,R2,G,SS,EN :Extended;
NP2 :Array [0..14] of Integer;
NK :Array [0..14] of Integer;
IK :Array [0..14] of Integer;
K :Array [0..14] of Integer;
NX :Array [0..14] of Integer;
MID :Array [0..14] of Extended;
D :Array [0..14] of Extended;
S1 :Array [0..14] of Extended;
S2 :Array [0..14] of Extended;
HN :Array [0..14] of Extended;
HP :Array [0..14] of Extended;
H :Array [0..14] of Extended;
XR :Array [0..63] of Extended;
WR :Array [0..63] of Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41;
begin
IERR := 0;
FN := N;
EN := E/FN;
QS80E(2,XR,WR);
RX := XR[0];
RW := WR[0];
V := 1.e0;
for I:=1 to N do
 begin
  NP[I-1] := 2;
  NP2[I-1] := 1;
  X[(I-1)+0*N] := RX;
  W[(I-1)+0*N] := RW;
  MID[I-1] := (A[I-1]+B[I-1])/2.e0;
  D[I-1] := (B[I-1]-A[I-1])/2.e0;
_1:
  V := V*D[I-1];
 end;
IS_ := 1;
goto _26;
_2:
R := S;
for I:=1 to N do
 begin
  S2[I-1] := R;
_3:
  NK[I-1] := I;
 end;
NN := 2;
MK := N;
_4:
NN := NN+2;
if ( NN-128 ) < 0
 then goto _8
 else if ( NN-128 ) > 0
       then goto _5
       else goto _8;
_5:
for I:=1 to N do
 begin
  if ( NK[I-1] ) < 0
   then goto _7
   else if ( NK[I-1] ) > 0
         then goto _6
         else goto _7;
_6:
  KN := NK[I-1];
  NP[KN-1] := NN;
_7:
 end;
goto _40;
_8:
QS80E(NN,XR,WR);
{ for I:=1 to N do //    }
I := 1;
while I<=N do
 begin
  if ( NK[I-1] ) < 0
   then goto _14
   else if ( NK[I-1] ) > 0
         then goto _9
         else goto _9;
_9:
  KN := NK[I-1];
  NP[KN-1] := NN;
  N2 := NN div 2;
  NP2[KN-1] := N2;
  for J:=1 to N2 do
   begin
    X[(KN-1)+(J-1)*N] := XR[J-1];
_10:
    W[(KN-1)+(J-1)*N] := WR[J-1];
   end;
  S1[KN-1] := S2[KN-1];
  IS_ := 2;
  goto _26;
_11:
  S2[KN-1] := S;
  if ( Abs(S2[KN-1]-S1[KN-1])-EN ) < 0
   then goto _12
   else if ( Abs(S2[KN-1]-S1[KN-1])-EN ) > 0
         then goto _13
         else goto _13;
_12:
  IK[KN-1] := NP[KN-1]-3;
  MK := MK-1;
  NK[I-1] := -NK[I-1];
_13:
  NP[KN-1] := 2;
  NP2[KN-1] := 1;
  X[(KN-1)+0*N] := RX;
  W[(KN-1)+0*N] := RW;
_14:
  inc(I);
 end;
if ( MK ) < 0
 then goto _15
 else if ( MK ) > 0
       then goto _4
       else goto _15;
_15:
for I:=1 to N do
 begin
_16:
  NP[I-1] := IK[I-1];
 end;
IN_ := 1;
goto _19;
_17:
IN_ := 2;
_18:
R1 := R2;
_19:
for I:=1 to N do
 begin
  NP[I-1] := NP[I-1]+1;
  if ( NP[I-1]-128 ) < 0
   then goto _20
   else if ( NP[I-1]-128 ) > 0
         then goto _40
         else goto _20;
_20:
  N2 := NP[I-1]-NP[I-1] div 2;
  NP2[I-1] := N2;
  NN := NP[I-1];
  QS80E(NN,XR,WR);
  for J:=1 to N2 do
   begin
    X[(I-1)+(J-1)*N] := XR[J-1];
_21:
    W[(I-1)+(J-1)*N] := WR[J-1];
   end;
 end;
IS_ := 3;
goto _26;
_22:
R2 := S;
case IN_ of
 1: goto _17;
 2: goto _23;
end;
_23:
if ( Abs(R2-R1)-E ) < 0
 then goto _24
 else if ( Abs(R2-R1)-E ) > 0
       then goto _18
       else goto _18;
_24:
RINT := R2;
for I:=1 to N do
 begin
_25:
  NP[I-1] := NP[I-1]-1;
 end;
goto _41;
_26:
S := 0.e0;
for L:=2 to N do
 begin
_27:
  K[L-1] := 1;
 end;
K[0] := 0;
_28:
L := 1;
_29:
if ( K[L-1]-NP2[L-1] ) < 0
 then goto _31
 else if ( K[L-1]-NP2[L-1] ) > 0
       then goto _30
       else goto _30;
_30:
K[L-1] := 1;
L := L+1;
if ( L-N ) < 0
 then goto _29
 else if ( L-N ) > 0
       then goto _39
       else goto _29;
_31:
K[L-1] := K[L-1]+1;
MN := 0;
for J:=1 to N do
 begin
//  if ( K[J-1] = (NP[J-1]/2+1) )
  if ( K[J-1] = (NP[J-1] div 2 + 1) )
   then goto _32;
  MN := MN+1;
  NX[MN-1] := J;
_32:
 end;
G := 1.e0;
for J:=1 to N do
 begin
  KK := K[J-1];
  G := G*W[(J-1)+(KK-1)*N];
  HN[J-1] := MID[J-1]-X[(J-1)+(KK-1)*N]*D[J-1];
  HP[J-1] := MID[J-1]+X[(J-1)+(KK-1)*N]*D[J-1];
_33:
  H[J-1] := HP[J-1];
 end;
SS := F(H);
if ( MN ) < 0
 then goto _38
 else if ( MN ) > 0
       then goto _34
       else goto _38;
_34:
J := 1;
_35:
if ( NX[J-1] ) < 0
 then goto _36
 else if ( NX[J-1] ) > 0
       then goto _37
       else goto _36;
_36:
NX[J-1] := -NX[J-1];
KK := NX[J-1];
H[KK-1] := HP[KK-1];
J := J+1;
if ( J-MN ) < 0
 then goto _35
 else if ( J-MN ) > 0
       then goto _38
       else goto _35;
_37:
KK := NX[J-1];
H[KK-1] := HN[KK-1];
NX[J-1] := -NX[J-1];
SS := SS+F(H);
goto _34;
_38:
S := S+G*SS;
goto _28;
_39:
S := V*S;
case IS_ of
 1: goto _2;
 2: goto _11;
 3: goto _22;
end;
_40:
IERR := 65;
UTQS13(IERR,3);
_41:
end;

end.
